﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace i8050W_Basic_Info_Csharp
{
    public partial class Form1 : Form
    {
        byte slot = 0;
        ComboBox[] uConfig = new ComboBox[16];
        CheckBox[] uDO = new CheckBox[16];
        Label[] uDI = new Label[16];
        byte[] uioBit = new byte[16];
        public Form1()
        {
            int i = 0;
            InitializeComponent();

            Slot_cmb.Items.Clear();
            for (i = 0; i < 8; ++i)
            {
                Slot_cmb.Items.Add(string.Format("Slot {0}", i));
            }

            uConfig[0] = cboMode0;
            uConfig[1] = cboMode1;
            uConfig[2] = cboMode2;
            uConfig[3] = cboMode3;
            uConfig[4] = cboMode4;
            uConfig[5] = cboMode5;
            uConfig[6] = cboMode6;
            uConfig[7] = cboMode7;
            uConfig[8] = cboMode8;
            uConfig[9] = cboMode9;
            uConfig[10] = cboMode10;
            uConfig[11] = cboMode11;
            uConfig[12] = cboMode12;
            uConfig[13] = cboMode13;
            uConfig[14] = cboMode14;
            uConfig[15] = cboMode15;
            uDO[0] = ckDO0;
            uDO[1] = ckDO1;
            uDO[2] = ckDO2;
            uDO[3] = ckDO3;
            uDO[4] = ckDO4;
            uDO[5] = ckDO5;
            uDO[6] = ckDO6;
            uDO[7] = ckDO7;
            uDO[8] = ckDO8;
            uDO[9] = ckDO9;
            uDO[10] = ckDO10;
            uDO[11] = ckDO11;
            uDO[12] = ckDO12;
            uDO[13] = ckDO13;
            uDO[14] = ckDO14;
            uDO[15] = ckDO15;
            uDI[0] = lbDI0;
            uDI[1] = lbDI1;
            uDI[2] = lbDI2;
            uDI[3] = lbDI3;
            uDI[4] = lbDI4;
            uDI[5] = lbDI5;
            uDI[6] = lbDI6;
            uDI[7] = lbDI7;
            uDI[8] = lbDI8;
            uDI[9] = lbDI9;
            uDI[10] = lbDI10;
            uDI[11] = lbDI11;
            uDI[12] = lbDI12;
            uDI[13] = lbDI13;
            uDI[14] = lbDI14;
            uDI[15] = lbDI15;
        }

        private void Slot_cmb_SelectedIndexChanged(object sender, EventArgs e)
        {
            int ch = 0;
            UInt16 firmware = 0;
            UInt16 libVer = 0;
            UInt16 stat = 0;
            UInt32 doVal = 0;
            if (Slot_cmb.SelectedIndex != -1)
            {
                firmware = pac_i8050WNet.pac8050W.GetFirmwareVersion((byte)Slot_cmb.SelectedIndex);
                if (firmware == 255)
                {
                    MessageBox.Show("No I-8050W at slot " + Slot_cmb.SelectedIndex);
                    return;
                }
                else
                {
                    slot = (byte)Slot_cmb.SelectedIndex;
                    FW_Ver_txt.Text = firmware.ToString("X");
                    libVer = pac_i8050WNet.pac8050W.GetLibVersion();
                    Lib_Ver_txt.Text = libVer.ToString("X");
                }
                stat = pac_i8050WNet.pac8050W.UDIO_ReadConfig_16(slot);
                doVal = pac_i8050WNet.pac8050W.UDIO_ReadDO16(slot);
                for (ch = 0; ch < 16; ch++)
                {
                    uioBit[ch] = (byte)((stat >> ch) & 0x01);
                    uConfig[ch].SelectedIndex = uioBit[ch];
                    if (uioBit[ch] == 1)
                    {
                        uDO[ch].Visible = true;
                        uDI[ch].Visible = false;

                        if (((doVal >> ch) & 0x01) == 1)
                        {
                            uDO[ch].Checked = true;
                        }
                    }
                    else
                    {
                        uDO[ch].Visible = false;
                        uDI[ch].Visible = true;
                    }
                }
                timer1.Enabled = true;
            }
        }

        private void Write_DOBit(object sender, EventArgs e)
        {
            Int16 ch = 0;
            UInt32 doVal = 0;
            for (ch = 0; ch < 16; ++ch)
            {
                if (uDO[ch].Checked)
                {
                    doVal += (UInt16)(1 << ch);
                }
            }
            pac_i8050WNet.pac8050W.UDIO_WriteDO16(slot, (UInt16)doVal);
        }

        private void SetUIOConfig(object sender, EventArgs e)
        {
            int i = 0;
            UInt16 config = 0;
            Int16 ch = Int16.Parse(((ComboBox)sender).Tag.ToString());
            uioBit[ch] = (byte)uConfig[ch].SelectedIndex;
            for (i = 0; i < 16; i++)
            {
                config += (UInt16)(uioBit[i] << i);
            }
            pac_i8050WNet.pac8050W.UDIO_WriteConfig_16((byte)slot, config);

            if (uioBit[ch] == 1)
            {
                uDO[ch].Visible = true;
                uDI[ch].Visible = false;
            }
            else
            {
                uDO[ch].Visible = false;
                uDI[ch].Visible = true;
            }

        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            Int16 ch = 0;
            UInt16 diVal = 0;
            byte[] diBit = new byte[16];
            diVal = pac_i8050WNet.pac8050W.UDIO_DI16(slot);
            for (ch = 0; ch < 16; ch++)
            {
                diBit[ch] = (byte)((diVal >> ch) & 0x01);
                if (diBit[ch] == 1)
                {
                    uDI[ch].Text = "ON";
                }
                else
                {
                    uDI[ch].Text = "OFF";
                }
            }
            Application.DoEvents();
        }
    }
}
